# -*-coding:UTF-8-*-
# https://pypi.python.org/simple
import uuid
import os
import pymysql
import string

from random import randint
from Crypto.Cipher import AES  # pip install pycryptodome
from binascii import b2a_hex, a2b_hex
from tkinter import Frame, Label, Button, Entry, Message, Checkbutton, Tk, W, E, N, S, END, StringVar, IntVar
from tkinter.messagebox import showinfo, askyesno
from tkinter.filedialog import askopenfilename, askdirectory
from shutil import copy2, rmtree, move, Error
from os import mkdir, rename, _exit
from PIL import Image, ImageTk, ImageDraw, ImageFont, ImageFilter
from time import sleep
from requests import get
from requests.exceptions import ConnectionError
from re import findall
from time import time


''' 初始化数据 '''
password_legal_tip = False
User_info = ['username', 'password', 'id_num', 'real_name']
tip0, tip1 = False, False
rg_tip = False
temp_key, temp_iv, suffix, pathname, path, filename, filepath = '', '', '', '', '', '', ''
new_user = ['', '']
acc = ''
weak_cipher_list = ['1234', '2345', '3456', '4567', '5678', '6789', '7890',
                    '111', '222', '333', '444', '555', '666', '777', '888', '999', '000',
                    'qwe', 'asd', 'zxc', 'QWE', 'ASD', 'ZXC',
                    ]
""" 函数 """
def get_ip():
    try:
        ip_html = get("http://txt.go.sohu.com/ip/soip")    # 返回公网ip的网站
        cur_public_ip = findall(r'\d+.\d+.\d+.\d+', ip_html.text)
        # 从响应中匹配公网ip
        return cur_public_ip[0]
    except ConnectionError:
        tip_window0 = Tk()
        tip_window0.geometry('0x0+0+0')
        showinfo('提示', '网络未连接！')
        _exit(0)

def DataBase_operation(sql_string=''):
    conn.connect()
    cursor = conn.cursor()
    row = cursor.execute(sql_string)
    cursor.close()
    conn.commit()
    conn.close()
    return row

def if_acc_exist():
    return DataBase_operation('select id from wd_info where id="%s"' % acc)

def if_login_success():
    conn.connect()
    cursor = conn.cursor()
    user = username.get()
    pwd = password.get()
    sql0 = 'select * from user_info where username=%s and password=%s'
    sql1 = 'select * from user_info where id=%s and password=%s'
    row0 = cursor.execute(sql0, (user, pwd))
    row1 = cursor.execute(sql1, (user, pwd))
    rows = row0 + row1

    if security.get() == security_code and rows:
        if row0:
            sql2 = 'update user_info set ip=%s where username=%s and password=%s'
        else:
            sql2 = 'update user_info set ip=%s where id=%s and password=%s'
        cursor.execute(sql2, (your_ip, user, pwd))
        cursor.close()
        conn.commit()
        conn.close()
        return True
    else:
        cursor.close()
        conn.close()
        return False

def if_username_exist(string0=new_user[0]):
    conn.connect()
    cursor = conn.cursor()
    sql = 'select * from user_info where username=%s'
    rows = cursor.execute(sql, string0)
    cursor.close()
    conn.close()
    return rows

def if_exist_repeat(password0):
    for i in weak_cipher_list:
        if i in password0:
            return True
    return False

def if_string_legal(string0, p=0):
    def isChinese(character):
        return '\u4e00' <= character <= '\u9fff'

    def isSpecialCode(code):
        return code in '~!@#$%^'

    if p == 0:
        for one in string0:
            # 中文、字母、数字
            if isChinese(one) or one.isalpha() or one.isdigit():
                continue
            else:
                return False
        return True
    if p == 1:
        for one in string0:
            # 字母、数字、特殊字符'~!@#$%^'
            if one.isalpha() or one.isdigit() or isSpecialCode(one):
                continue
            else:
                return False
        return True

def if_id_exist():
    return DataBase_operation('select * from user_info where id="%s"' % str(acc))

def search_id(username0, password0):
    conn.connect()
    cursor = conn.cursor()
    sql_string0 = 'select * from user_info where id="%s" and password="%s"' % (username0, password0)
    sql_string1 = 'select * from user_info where username="%s" and password="%s"' % (username0, password0)
    if cursor.execute(sql_string0):
        id_num = cursor.fetchone()[0]
    elif cursor.execute(sql_string1):
        id_num = cursor.fetchone()[0]
    cursor.close()
    conn.commit()
    conn.close()
    return id_num

def search_real_name():
    conn.connect()
    cursor = conn.cursor()
    sql_string = 'select id,Chinese_name from wd_info where id="%s"' % User_info[2]
    row = cursor.execute(sql_string)
    if row:
        real_name = cursor.fetchone()[1]
    else:
        real_name = '陌生人'
    cursor.close()
    conn.commit()
    conn.close()
    return real_name

def password_level(string0):
    a = b = c = d = 0
    if len(string0) < 6:  # 长度小于8，直接判断为弱
        return 1
    else:
        for one in string0:  # 遍历keys
            if one in string.digits:
                a = 1  # 如果有数字，则数字种类存在，记作1
            elif one in string.ascii_lowercase:
                b = 1  # 如果有小写字母，则小写字母存在，记作1
            elif one in string.ascii_uppercase:
                c = 1  # 如果有大写字母，则大小字母存在，记作1
            elif one in string.punctuation:
                d = 1  # 如果有特殊字符，则特殊字符存在，记作1
            else:  # 其他的直接跳过
                pass
        return sum([a, b, c, d])  # 计算种类和

def try_submit():
    global acc, your_ip
    acc = active_var.get()
    if acc == '':
        showinfo('提示', '邀请码不能为空')
    elif len(acc) != 12 or not acc.isdigit() or not if_acc_exist():
        showinfo('提示', '邀请码错误')
    elif if_id_exist():
        showinfo('提示', '邀请码已被激活')
    elif password_legal_tip and event_check('try') and not if_username_exist():
        your_ip = get_ip()
        add_user(new_user[0], new_user[1])
        showinfo('提示', '注册成功！')

def log_black_ip(p):
    if p == 'add':
        DataBase_operation('insert into black_ip(ip,time_stamp,times) values ("%s","%s","%s")' % (your_ip, time(), '1'))
    if p == 'del':
        DataBase_operation('delete from black_ip where ip="%s"' % your_ip)
def search(name, date_base='user_info'):
    pass
def add_user(username0, password0):
    conn.connect()
    cursor = conn.cursor()
    sql = 'insert into user_info(id,username,password,ip) values (%s,%s,%s,%s)'
    rows = cursor.execute(sql, (acc, username0, password0, your_ip))
    cursor.close()
    conn.commit()
    conn.close()
    return rows

def win_info():
    global tip0, tip1, key, iv
    w = window.winfo_width()
    # window.title(' ' * int(w / 8) + '猪猪加密')
    window.title('欢迎回家,%s' % User_info[3])
    temp0 = iv0.get()
    temp1 = e0.get()
    if temp0 == 0:
        key = temp_key
        m0.config(font=('等线', 10))
        if len(temp1) > 16:
            e0.delete(16, END)
        e0.config(state='normal')
        tip0 = True
    elif len(temp1) == 16:
        e0.config(state='disable')
        m0.config(font=('等线', 10, 'overstrike'))
        key = e0.get()
    elif tip0:
        iv0.set(0)
        showinfo('提示', '密钥为16位')
        tip0 = False

    temp0 = iv1.get()
    temp1 = e1.get()
    if temp0 == 0:
        m1.config(font=('等线', 10))
        iv = temp_iv
        if len(temp1) > 16:
            e1.delete(16, END)
        e1.config(state='normal')
        tip1 = True
    elif len(temp1) == 16:
        e1.config(state='disable')
        m1.config(font=('等线', 10, 'overstrike'))
        iv = e1.get()
    elif tip1:
        iv1.set(0)
        showinfo('提示', '密钥为16位')
        tip1 = False
    show_message('当前密钥为:                  key(%s)                  iv(%s)' % (key, iv))
    window.after(300, win_info)
    pass

def log_win_info():
    global img_sc, tk_img_sc, new_user, password_legal_tip
    log_win.title('软件登录-ip:%s' % your_ip)

    def level():
        if password_level(new_user[1]) == 1:
            message_var1.set('极弱')
            reg_mes1.config(fg='red')
        elif password_level(new_user[1]) == 2:
            message_var1.set('简单')
            reg_mes1.config(fg='yellow')
        elif password_level(new_user[1]) == 3:
            message_var1.set('强')
            reg_mes1.config(fg='yellowgreen')
        elif password_level(new_user[1]) == 4:
            message_var1.set('极强')
            reg_mes1.config(fg='green')
        if if_exist_repeat(new_user[1]):
            message_var1.set('傻瓜密码')
            reg_mes1.config(fg='red')


    def string_length():
        length = len(new_user[1])
        message_var2.set(str(length))
        if new_user[1] == '密码':
            message_var2.set('0')
        if 6 <= length <= 16:
            reg_mes2.config(fg='green')
        else:
            reg_mes2.config(fg='red')

    if os.path.exists('img'):
        img_sc = Image.open('img/SecurityCode.png')
        tk_img_sc = ImageTk.PhotoImage(img_sc)
        rmtree('img')
        security_img.config(image=tk_img_sc)
    if rg_tip:
        new_user = [u_var.get(), p_var.get()]
        level()
        string_length()
        if rep_var.get() == new_user[1]:
            message_var0.set('一致')
            reg_mes0.config(fg='green')
        else:
            message_var0.set('不一致')
            reg_mes0.config(fg='red')
        if if_string_legal(new_user[1], p=1) and 16 >= len(new_user[1]) >= 6 and password_level(new_user[1]) >= 2 \
                and not if_exist_repeat(new_user[1]):
            message_var3.set('可用')
            reg_mes3.config(fg='green')
            password_legal_tip = True
        else:
            message_var3.set('不可用')
            reg_mes3.config(fg='red')
            password_legal_tip = False
    try:
        log_win.after(200, log_win_info)
    except Exception:
        print('loading...')

# 如果text不足16位的倍数就用空格补足为16位
def add_to_16(text):
    if len(text.encode('utf-8')) % 16:
        add = 16 - (len(text.encode('utf-8')) % 16)
    else:
        add = 0
    text = text + ('\0' * add)
    return text.encode('utf-8')

# 加密函数
def encrypt(text, key, iv):
    mode = AES.MODE_CBC
    text = add_to_16(text)
    cryptos = AES.new(key.encode('utf-8'), mode, iv.encode('utf-8'))
    cipher_text = cryptos.encrypt(text)
    # 因为AES加密后的字符串不一定是ascii字符集的，输出保存可能存在问题，所以这里转为16进制字符串
    return b2a_hex(cipher_text)

# 解密后，去掉补足的空格用strip() 去掉
def decrypt(text, key, iv):
    mode = AES.MODE_CBC
    cryptos = AES.new(key.encode('utf-8'), mode, iv.encode('utf-8'))
    plain_text = cryptos.decrypt(a2b_hex(text))
    return bytes.decode(plain_text).rstrip('\0')

def code_string():
    string = Entry_code.get()
    if string != '':
        try:
            code = encrypt(string, key, iv)
            v0.set('')
            v1.set(code)
        except ValueError:
            showinfo('警告', '尝试加密失败，密钥只能为数字和字母！')
    else:
        if askyesno('提示', '当前为空值，是否继续？'):
            try:
                code = encrypt(string, key, iv)
                v0.set('')
                v1.set(code)
            except ValueError:
                showinfo('警告', '尝试加密失败，密钥只能为数字和字母！')

def decode_code():
    code = Entry_decode.get()
    if code != '':
        try:
            string = decrypt(code, key, iv)
            v0.set(string)
            v1.set('')
        except UnicodeDecodeError:
            showinfo('警告', '尝试解密失败，非同一公钥!')
        except ValueError:
            showinfo('警告', '尝试解密失败，密钥只能为数字和字母！')
    else:
        if askyesno('提示', '当前为空值，是否继续？'):
            try:
                string = decrypt(code, key, iv)
                v0.set(string)
                v1.set('')
            except ValueError:
                showinfo('警告', '尝试解密失败，密钥只能为数字和字母！')

def copy_key():
    window.clipboard_clear()
    window.clipboard_append(key)
    showinfo('提示', '复制成功')

def copy_iv():
    window.clipboard_clear()
    window.clipboard_append(iv)
    showinfo('提示', '复制成功')

def show_message(string):
    f = Frame(window, bg='black')
    f.grid(row=4, sticky=W + E)
    message = Message(f, text=string, aspect=2000, bg='black', fg='white')
    message.grid(sticky=W)

def message_click_event_1(event):
    v2.set(key)

def message_click_event_2(event):
    v3.set(iv)

def fresh():
    fresh_key(False)
    fresh_iv(False)

def fresh_key(state=True):
    global key, temp_key
    res = str(uuid.uuid4())
    res = res.replace('-', '')
    key = res[:16]
    temp_key = key
    if state:
        m0.config(text='公钥:  %s [点此自动填入key值]' % key)

def fresh_iv(state=True):
    global iv, temp_iv
    res = str(uuid.uuid4())
    res = res.replace('-', '')
    iv = res[:16]
    temp_iv = iv
    if state:
        m1.config(text='私钥:  %s [点此自动填入iv值]' % iv)

def code_file():
    mkdir('temp')
    can_suffix_list = ['py', 'java', 'cpp', 'txt']
    flag_list = []
    for i in can_suffix_list:
        flag_list.append(suffix == i)
    if any(flag_list):
        copy2(filepath, 'temp/' + filename + 'txt')
        f = open('temp/' + filename + 'txt', 'r', encoding='utf-8')
        string = f.read()
        f.close()
        code = encrypt(string, key, iv)
        type_code = str(encrypt(suffix, key, iv))
        f = open(key + '_' + iv + '_' + type_code + '.txt', 'w+')
        f.write(str(code))
        f.close()
        rename(key + '_' + iv + '_' + type_code + '.txt', key + '_' + iv + '_' + type_code + '.zlh')
        try:
            move(key + '_' + iv + '_' + type_code + '.zlh', askdirectory())
        except Error:
            pass
        showinfo('提示', '加密成功！')
    else:
        type_code = str(encrypt(suffix, key, iv))
        copy2(filepath, askdirectory() + '/' + key + '_' + iv + '_' + type_code + '.zlh')
        showinfo('提示', '加密成功！')
        # if filepath != '':
        #     showinfo('提示', '暂时不支持该格式，正在努力开发中。。。')
    rmtree('temp')


def decode_file():
    global key, iv, suffix
    mkdir('temp')
    copy2(filepath, 'temp/' + filename + suffix)
    info = filename.split('_')
    suffix = decrypt(info[2][2:].split('\'')[0], info[0], info[1])
    can_suffix_list = ['py', 'java', 'cpp', 'txt']
    flag_list = []
    for i in can_suffix_list:
        flag_list.append(suffix == i)
    if any(flag_list):
        f = open('temp/' + filename + 'zlh', 'r')
        code = f.read()
        f.close()
        string = decrypt(code[2:].split('\'')[0], info[0], info[1])
        f = open('猪猪解密.txt', 'w+', encoding='utf-8')
        f.write(string)
        f.close()
        rename('猪猪解密.txt', '猪猪解密.' + suffix)
        rmtree('temp')
        try:
            move('猪猪解密.' + suffix, askdirectory())
        except Error:
            pass
        showinfo('提示', '解密成功！')
    else:
        copy2(filepath, askdirectory() + '/' + '猪猪解密.' + suffix)
        showinfo('提示', '解密成功！')


def select_file():
    global suffix, pathname, path, filename, filepath
    filepath = askopenfilename()
    if filepath == '':
        return
    filename = filepath.split('/')[-1:][0]
    suffix = filename.split('.')[-1:][0]
    path = filepath.replace(filename, '')
    filename = filename.replace(suffix, '')
    my_suffix = ['zlh', suffix]
    # 后缀为.zlh
    if suffix == my_suffix[0]:
        decode_file()
    # 后缀为其他文件
    else:
        code_file()


def if_login():
    if (username.get() != '0' or password.get() != '0') and askyesno('询问', '是否退出程序？'):
        _exit(0)
    elif username.get() == '0' and password.get() == '0':
        log_win.destroy()


def shark(state='wrong'):
    if state == 'error':
        for i in range(3):
            m.config(bg='red')
            log_win.update()
            sleep(0.2)
            m.config(bg='black')
            log_win.update()
            sleep(0.2)
    if state == 'wrong':
        for i in range(3):
            m.config(bg='yellow')
            log_win.update()
            sleep(0.2)
            m.config(bg='black')
            log_win.update()
            sleep(0.2)
    if state == 'right':
        m.config(bg='green')
        for i in range(21):
            m.config(anchor='w')
            var.set('█' * i)
            log_win.update()
            sleep(0.01)
        m.config(anchor='center')

# events
def event0(event):
    global your_ip, User_info
    l0.config(relief='raised')
    if username.get() == '' or password.get() == '':
        var.set('用户名或密码不能为空！')
        shark('wrong')
    elif security.get() == '':
        var.set('验证码不能为空！')
        shark('wrong')
    elif security.get() != security_code:
        fresh_event(0)
        var.set('验证码错误！')
        shark('error')
    elif not if_login_success():
        var.set('用户名或密码错误！')
        your_ip = get_ip()
        log_black_ip('add')
        fresh_event(0)
        shark('error')
    else:
        shark('right')
        your_ip = get_ip()
        log_black_ip('del')
        User_info = [username.get(), password.get()]
        id_num = search_id(User_info[0], User_info[1])
        User_info.append(id_num)
        User_info.append(search_real_name())
        log_win.destroy()

def event1(event):
    l0.config(relief='sunken')

def event2(event):
    pass

def rg_u_event(event):
    a = u_var.get()
    b = p_var.get()
    d = rep_var.get()
    if a == '用户名':
        u_var.set('')
    if b == '' or b == '密码':
        rg_e1.config(show='')
        p_var.set('密码')
    if d == '' or d == '确认密码':
        rg_e2.config(show='')
        rep_var.set('确认密码')

def rg_p_event(event):
    a = u_var.get()
    b = p_var.get()
    d = rep_var.get()
    if a == '':
        u_var.set('用户名')
    if b == '密码':
        rg_e1.config(show='*')
        p_var.set('')
    if d == '' or d == '确认密码':
        rep_var.set('确认密码')
        rg_e2.config(show='')

def rg_rep_event(event):
    a = u_var.get()
    b = p_var.get()
    d = rep_var.get()
    if a == '':
        u_var.set('用户名')
    if b == '' or  b == '密码':
        p_var.set('密码')
        rg_e1.config(show='')
    if d == '确认密码':
        rg_e2.config(show='*')
        rep_var.set('')

def event_check(p):
    if new_user[0] == '' or new_user[0] == '用户名':
        showinfo('警告', '用户名不能为空')
    elif not if_string_legal(new_user[0]):
        showinfo('警告', '用户名只能由字母、数字和汉字组成')
    elif if_username_exist():
        showinfo('警告', '用户名不合法')
    else:
        if p == 'try':
            pass
        else:
            showinfo('提示', '用户名可以放心使用')
        return True
    return False

def pwd_show_event(event):
    rg_e1.config(show='')

def pwd_hide_event(event):
    if p_var.get() != '密码':
        rg_e1.config(show='*')

def de_extend():
    global var, rg_tip
    rg_tip = False
    log_win.geometry('500x250+570+230')  # 扩展一个x=500~700的页面
    var.set('Welcome to https://zhuzhushop.top')
    m.config(bg='black')

def register_event0(event):
    global rg_tip, u_var, p_var, rep_var, active_var, rg_e1, rg_e2, message_var0, message_var1, message_var2, message_var3
    global reg_mes0, reg_mes1, reg_mes2, reg_mes3, reg_mes5
    u_var, p_var, rep_var, active_var = StringVar(), StringVar(), StringVar(), StringVar()
    message_var0, message_var1, message_var2, message_var3 = StringVar(), StringVar(), StringVar(), StringVar()
    u_var.set('用户名')
    p_var.set('密码')
    rep_var.set('确认密码')
    message_var0.set('一致')
    message_var1.set('简单')
    message_var2.set(0)
    register.config(relief='raised')
    if not rg_tip:
        rg_tip = True
        log_win.geometry('700x250+370+230')  # 扩展一个x=500~700的页面
        # log_win.config(bg='skyblue')
        Label(log_win, bg='skyblue').place(x=500, y=0, width=200, height=250)
        Button(log_win, text='X', command=de_extend).place(x=675, y=0, width=25, height=25)
        Label(log_win, bg='blue').place(x=500, y=0, width=175, height=25)
        rg_e0 = Entry(log_win, textvariable=u_var)
        rg_e0.place(x=530, y=30, width=140, height=30)
        rg_e0.bind('<FocusIn>', rg_u_event)
        rg_e1 = Entry(log_win, textvariable=p_var)
        rg_e1.place(x=530, y=60, width=100, height=30)
        rg_e1.bind('<FocusIn>', rg_p_event)
        btn0 = Button(log_win, text='👁')
        btn0.place(x=640, y=60, width=30, height=30)
        btn0.bind('<Button-1>', pwd_show_event)
        btn0.bind('<ButtonRelease-1>', pwd_hide_event)
        btn1 = Button(log_win, text='√', command=try_submit)
        btn1.place(x=640, y=90, width=30, height=30)
        rg_e2 = Entry(log_win, textvariable=rep_var)
        rg_e2.place(x=530, y=90, width=100, height=30)
        rg_e2.bind('<FocusIn>', rg_rep_event)
        Message(log_win, bg='black', fg='white', anchor='w', text='两次密码输入:', aspect=500)\
            .place(x=520, y=125, width=100, height=20)
        Message(log_win, bg='black', fg='white', anchor='w', text='密码强度:', aspect=500)\
            .place(x=520, y=145, width=100, height=20)
        Message(log_win, bg='black', fg='white', anchor='w', text='密码长度:', aspect=500)\
            .place(x=520, y=165, width=100, height=20)
        Message(log_win, bg='black', fg='white', anchor='w', text='密码是否可用:', aspect=500)\
            .place(x=520, y=185, width=100, height=20)
        reg_mes0 = Message(log_win, bg='black', fg='white', textvariable=message_var0, aspect=500)
        reg_mes0.place(x=620, y=125, width=60, height=20)
        reg_mes1 = Message(log_win, bg='black', fg='white', textvariable=message_var1, aspect=500)
        reg_mes1.place(x=620, y=145, width=60, height=20)
        reg_mes2 = Message(log_win, bg='black', fg='white', textvariable=message_var2, aspect=500)
        reg_mes2.place(x=620, y=165, width=60, height=20)
        reg_mes3 = Message(log_win, bg='black', fg='white', textvariable=message_var3, aspect=500)
        reg_mes3.place(x=620, y=185, width=60, height=20)
        reg_mes4 = Message(log_win, bg='black', fg='white', text='[点此检验用户名是否可用]', aspect=500)
        reg_mes4.place(x=520, y=205, width=160, height=20)
        reg_mes4.bind('<ButtonRelease-1>', event_check)
        # 激活码12位
        Label(log_win, text='输入激活码:', bg='black', fg='white')\
            .place(x=520, y=225, width=80, height=20)
        reg_mes5 = Entry(log_win, bg='black', fg='white', textvariable=active_var)
        reg_mes5.place(x=590, y=225, width=90, height=20)
        shark('right')


def register_event1(event):
    register.config(relief='sunken')


def fresh_event(event):
    global security_code
    mkdir('img')
    security_code = create_security_code()
    log_win_info()


def create_security_code():
    def random_color():
        c1 = randint(0, 255)
        c2 = randint(0, 255)
        c3 = randint(0, 255)
        return c1, c2, c3

    def generate_picture(width=75, height=30):
        return Image.new('RGB', (width, height), random_color())

    def random_str():
        return str(uuid.uuid4()).split('-')[1]

    now_code = random_str()

    def draw_str(count, image, font_size):
        """
        在图片上写随机字符
        :param count: 字符数量
        :param image: 图片对象
        :param font_size: 字体大小
        :return:
        """
        draw = ImageDraw.Draw(image)
        # 获取一个font字体对象参数是ttf的字体文件的目录，以及字体的大小
        font_file = path.join(r'C:\\Windows\\Fonts\\Verdana\\verdanab.ttf')
        font = ImageFont.truetype(font_file, size=font_size)
        temp = []
        for i in range(count):
            random_char = now_code
            draw.text((10 + i * 30, -2), random_char, random_color(), font=font)
            temp.append(random_char)

        valid_str = "".join(temp)  # 验证码
        return valid_str, image

    def noise(image, width=75, height=30, line_count=3, point_count=20):
        """
        :param image: 图片对象
        :param width: 图片宽度
        :param height: 图片高度
        :param line_count: 线条数量
        :param point_count: 点的数量
        :return:
        """
        draw = ImageDraw.Draw(image)
        for i in range(line_count):
            x1 = randint(0, width)
            x2 = randint(0, width)
            y1 = randint(0, height)
            y2 = randint(0, height)
            draw.line((x1, y1, x2, y2), fill=random_color())
            # 画点
            for i in range(point_count):
                draw.point([randint(0, width), randint(0, height)], fill=random_color())
                x = randint(0, width)
                y = randint(0, height)
                draw.arc((x, y, x + 4, y + 4), 0, 90, fill=random_color())
        return image

    image = generate_picture()
    valid_str, image = draw_str(1, image, 20)
    image = noise(image)
    return_image = image.resize((75, 30))
    return_image.save('img/SecurityCode.png')
    return now_code


if __name__ == '__main__':
    try:
        your_ip = get_ip()  # 得到本机IP地址
        conn = pymysql.connect(  # 检查数据库连接
            host='xxx.xxx.xxx.xxx',  # ip
            port=3306,  # 端口
            user='root',  # 用户名
            password='root',  # 密码
            db='Code_base',  # 连接的数据库
            charset='utf8'  # 编码方式
        )
    except pymysql.err.OperationalError:
        tip_window = Tk()
        tip_window.geometry('0x0+0+0')
        showinfo('提示', '服务器维护中！')
        _exit(0)

    key = ''
    iv = ''
    mkdir('img')
    # 图片
    try:
        res_img0 = get('https://pic.imgdb.cn/item/62842a700947543129d90ebb.png').content
        res_img1 = get('https://pic.imgdb.cn/item/628533bc0947543129f0aae7.png').content
        res_img2 = get('https://pic.imgdb.cn/item/6285374d0947543129f25fbc.png').content
        with open('img/bg.png', 'wb') as f:
            f.write(res_img0)
        with open('img/button.png', 'wb') as f:
            f.write(res_img1)
        with open('img/register.png', 'wb') as f:
            f.write(res_img2)
    except Exception:
        pass
    security_code = create_security_code()
    img_bg = Image.open('img/bg.png')
    img_button = Image.open('img/button.png')
    img_sc = Image.open('img/SecurityCode.png')
    img_register = Image.open('img/register.png')
    log_win = Tk()
    var = StringVar()
    var.set('Welcome to https://zhuzhushop.top')
    tk_img_bg = ImageTk.PhotoImage(img_bg)
    tk_img_button = ImageTk.PhotoImage(img_button)
    tk_img_sc = ImageTk.PhotoImage(img_sc)
    tk_img_register = ImageTk.PhotoImage(img_register)
    rmtree('img')
    log_win.geometry('500x250+570+230')
    log_win.resizable(False, False)
    log_win.title('激活软件')
    # 背景图
    Label(log_win, image=tk_img_bg).place(x=0, y=0)
    # 用户名，密码
    Label(log_win, text='用户名:', font=('宋体', 15), bg='red').place(x=160, y=30)
    Label(log_win, text='密  码:', font=('宋体', 15), bg='red').place(x=160, y=60)
    username = Entry(log_win)
    username.place(x=250, y=30, height=25, width=140)
    username.bind('<KeyPress-Return>', event0)
    password = Entry(log_win, show='*')
    password.place(x=250, y=60, height=25, width=200)
    password.bind('<KeyPress-Return>', event0)
    password.bind('<FocusIn>', event2)
    # 注册按钮
    register = Label(log_win, image=tk_img_register, relief='raised', bd=1)
    register.place(x=400, y=30, height=25, width=50)  # 50,25
    register.bind('<ButtonRelease-1>', register_event0)
    register.bind('<Button-1>', register_event1)
    # 安全验证码
    security_img = Label(log_win, image=tk_img_sc)
    security_img.place(x=160, y=90, height=30, width=75)
    security_img.bind('<ButtonRelease-1>', fresh_event)
    security = Entry(log_win)
    security.place(x=250, y=90, height=30, width=100)
    security.bind('<KeyPress-Return>', event0)
    # 自制登录按钮
    l0 = Label(log_win, image=tk_img_button, relief='raised', bd=1)
    l0.place(x=360, y=90, height=30, width=90)  # 90,30
    l0.bind('<ButtonRelease-1>', event0)
    l0.bind('<Button-1>', event1)
    # 消息提示框
    m = Message(log_win, textvariable=var, bg='black', font=('黑体', 10), fg='white', aspect=18000)
    m.place(x=160, y=135, height=30, width=290)
    # 10ms 更新数据
    try:
        log_win_info()
    except Exception:
        print('loading...')
    # 关闭事件
    log_win.protocol('WM_DELETE_WINDOW', if_login)
    log_win.mainloop()

    # 刷新key、iv数据
    fresh()

    # 用户界面
    window = Tk()
    window.geometry("+440+310")
    window.config(background='skyblue')
    window.resizable(False, False)
    v0 = StringVar()
    v1 = StringVar()
    v2 = StringVar()
    v3 = StringVar()
    iv0 = IntVar()
    iv1 = IntVar()
    """"""
    frame_top = Frame(window, width=100, bg='skyblue')
    frame_top.grid(row=0, column=0, sticky=W + E)
    Label(frame_top, text='明文内容：', font=('黑体', 12), width=10, bg='skyblue', fg='red') \
        .grid(row=0, column=0, padx=10, pady=5, sticky=E)
    Entry_code = Entry(frame_top, width=60, font=('黑体', 12), textvariable=v0)
    Entry_code.grid(row=0, column=1, padx=10, pady=5, stick=W)
    Button(frame_top, text='加密', command=code_string).grid(row=0, column=2, padx=10, pady=5, sticky=E)
    """"""
    frame_bottom = Frame(window, width=100, bg='skyblue')
    frame_bottom.grid(row=1, column=0, sticky=W + E)
    Label(frame_bottom, text='加密内容：', font=('黑体', 12), width=10, bg='skyblue') \
        .grid(row=0, column=0, padx=10, pady=5, sticky=E)
    Entry_decode = Entry(frame_bottom, width=60, font=('黑体', 12), textvariable=v1)
    Entry_decode.grid(row=0, column=1, padx=10, pady=5, stick=W)
    Button(frame_bottom, text='解密', command=decode_code).grid(row=0, column=2, padx=10, pady=5, sticky=E)
    """"""
    Button(window, text='导入文件自动选择', command=select_file).grid(sticky=N + S, row=0, column=1, rowspan=5)
    """"""
    frame1 = Frame(window, bg='black')
    frame1.grid(row=2, column=0, sticky=W + E)
    m0 = Message(frame1, text='公钥:  %s [点此自动填入key值]' % key, aspect=2000, bg='black', fg='white', font=('等线', 10))
    m0.grid(row=0, column=1, sticky=W)
    m0.bind('<ButtonRelease-1>', message_click_event_1)
    m1 = Message(frame1, text='私钥:  %s [点此自动填入iv值]' % iv, aspect=2000, bg='black', fg='white', font=('等线', 10))
    m1.grid(row=1, column=1, sticky=W)
    m1.bind('<ButtonRelease-1>', message_click_event_2)
    Button(frame1, text='复制公钥', command=copy_key).grid(row=0, column=2, sticky=W + E, padx=5, pady=3)
    Button(frame1, text='刷新公钥', command=fresh_key).grid(row=0, column=0, sticky=W + E, padx=5, pady=3)
    e0 = Entry(frame1, width=20, font=('黑体', 12), textvariable=v2, fg='blue')
    e0.grid(row=0, column=4, sticky=W + E, ipady=4, pady=3)
    # e0.bind('<ButtonRelease-1>', copy_key)
    Message(frame1, text='自定义公钥:', bg='black', font=('黑体', 9), fg='white', aspect=180) \
        .grid(row=0, column=3, sticky=W + E)
    Checkbutton(frame1, bg='black', variable=iv0, onvalue=1, offvalue=0).grid(row=0, column=5, sticky=W + E)

    Button(frame1, text='复制私钥', command=copy_iv).grid(row=1, column=2, sticky=W + E, padx=5, pady=3)
    Button(frame1, text='刷新私钥', command=fresh_iv).grid(row=1, column=0, sticky=W + E, padx=5, pady=3)
    e1 = Entry(frame1, width=10, font=('黑体', 12), textvariable=v3, fg='blue')
    e1.grid(row=1, column=4, sticky=W + E, ipady=4, pady=3)
    # e1.bind('<ButtonRelease-1>', copy_iv)
    Message(frame1, text='自定义私钥:', bg='black', font=('黑体', 9), fg='white', aspect=180) \
        .grid(row=1, column=3, sticky=W + E)
    Checkbutton(frame1, bg='black', variable=iv1, onvalue=1, offvalue=0).grid(row=1, column=5, sticky=W + E)
    win_info()
    window.mainloop()
